package com.example.controller;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.List;

import javax.servlet.http.HttpSession;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.client.RestTemplate;

import com.example.dto.ZipcodeDataDto;
import com.example.dto.ZipcodeDto;
import com.example.dto.ZipcodeDto2;
import com.example.service.ZipcodeService;
import com.fasterxml.jackson.core.JsonParseException;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.fasterxml.jackson.databind.ObjectMapper;

@Controller
public class ZipcodeController {

ZipcodeService zipcodeService = new ZipcodeService() ;
	
	@RequestMapping(value="/")
	public String index() {
		return "zipcode";
	}
	
	@RequestMapping(value="/result")
	public String confirm(@RequestParam("zipcode") String zipcode) {

        //webAPiのURL
    	String url = "http://zipcloud.ibsnet.co.jp/api/search?zipcode={zipcode}";
    	
    	//webAPiからJsonをStringで取得
		//System.out.println(zipcodeService.getZipcode(url,zipcode));
		
		//WebAPIからJsonをクラス型で取得
    	//ZipcodeDto zipcodeDto = zipcodeService.getZipcode2(url,zipcode);
		
		//Jsonファイルの定義(zipcodeのWebAPIと同じ形式）
		File file = new File("C:\\Users\\tokenbaraba\\Desktop\\Sample3\\src\\main\\resources\\json\\json1.json");
		ZipcodeDto zipcodeDto2 = zipcodeService.SerializeJsonData2(file);
		
		System.out.println(zipcodeDto2.getMassage());
		System.out.println(zipcodeDto2.getResults().get(0).getAddress1());
		System.out.println(zipcodeDto2.getResults().get(0).getAddress2());
		System.out.println(zipcodeDto2.getResults().get(0).getAddress3());
		System.out.println(zipcodeDto2.getResults().get(0).getKana1());
		System.out.println(zipcodeDto2.getResults().get(0).getKana2());
		System.out.println(zipcodeDto2.getResults().get(0).getKana3());
		System.out.println(zipcodeDto2.getResults().get(0).getPrefcode());
		System.out.println(zipcodeDto2.getResults().get(0).getZipcode());
		System.out.println(zipcodeDto2.getStatus());
		
		//Jsonファイルの定義（Jsonの形式を変更。括弧[]を削除）
		File file2 = new File("C:\\Users\\tokenbaraba\\Desktop\\Sample3\\src\\main\\resources\\json\\json2.json");
		ZipcodeDto2 zipcodeDto3 = zipcodeService.SerializeJsonData3(file2);
		
		System.out.println(zipcodeDto3.getMassage());
		System.out.println(zipcodeDto3.getResults().getAddress1());
		System.out.println(zipcodeDto3.getResults().getAddress2());
		System.out.println(zipcodeDto3.getResults().getAddress3());
		System.out.println(zipcodeDto3.getResults().getKana1());
		System.out.println(zipcodeDto3.getResults().getKana2());
		System.out.println(zipcodeDto3.getResults().getKana3());
		System.out.println(zipcodeDto3.getResults().getPrefcode());
		System.out.println(zipcodeDto3.getResults().getZipcode());
		System.out.println(zipcodeDto3.getStatus());

		return null;
		
	}
	
	
}
