package com.example.service;

import java.io.File;
import java.io.IOException;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.ui.Model;
import org.springframework.web.client.RestTemplate;

import com.example.dto.ZipcodeDto;
import com.example.dto.ZipcodeDto2;
import com.fasterxml.jackson.core.JsonParseException;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.fasterxml.jackson.databind.ObjectMapper;

public class ZipcodeService {
	
	@Autowired
	RestTemplate restTemplate = new RestTemplate();
	
	/**
	 * Json型WepAPIを取得
	 * @param zipcode
	 * @return　String
	 */
	public String getZipcode(String url,String zipcode) {
		return restTemplate.getForObject(url, String.class, zipcode);
	}
	
	/**
	 * Json型WebApiを取得
	 * @param zipcode
	 * @return　ZipcodeDto
	 */
	public ZipcodeDto getZipcode2(String url,String zipcode) {
		return SerializeJsonData(restTemplate.getForObject(url, String.class, zipcode));
	}
	
	/**
	 * Jsonをクラス型に変換
	 * @param Jsondata
	 * @return
	 */
	public ZipcodeDto SerializeJsonData(String Jsondata) {
		ObjectMapper objectMapper = new ObjectMapper();
		try {
			return objectMapper.readValue(Jsondata, ZipcodeDto.class);
		} catch (IOException e) {
			// TODO 自動生成された catch ブロック
			e.printStackTrace();
		}
		return null;
	}
	
	/**
	 * Jsonをクラス型に変換
	 * @param zipcode
	 * @return ZipcodeDto
	 */
	public ZipcodeDto SerializeJsonData2(File Jsondata) {
		ObjectMapper objectMapper = new ObjectMapper();
		try {
			return objectMapper.readValue(Jsondata, ZipcodeDto.class);
		} catch (IOException e) {
			// TODO 自動生成された catch ブロック
			e.printStackTrace();
		}
		return null;
	}
	
	public ZipcodeDto2 SerializeJsonData3(File Jsondata) {
		ObjectMapper objectMapper = new ObjectMapper();
		try {
			return objectMapper.readValue(Jsondata, ZipcodeDto2.class);
		} catch (IOException e) {
			// TODO 自動生成された catch ブロック
			e.printStackTrace();
		}
		return null;
	}
}
